---
title: llarp::vpn::IRouteManager

---

# llarp::vpn::IRouteManager





Inherited by [llarp::apple::RouteManager](Classes/classllarp_1_1apple_1_1RouteManager.md), [llarp::vpn::AndroidRouteManager](Classes/classllarp_1_1vpn_1_1AndroidRouteManager.md), [llarp::vpn::LinuxRouteManager](Classes/classllarp_1_1vpn_1_1LinuxRouteManager.md), [llarp::vpn::Win32RouteManager](Classes/classllarp_1_1vpn_1_1Win32RouteManager.md)

## Public Types

|                | Name           |
| -------------- | -------------- |
| using std::variant< [huint32_t](Classes/structllarp_1_1huint__t.md), [huint128_t](Classes/structllarp_1_1huint__t.md) > | **[IPVariant_t](Classes/classllarp_1_1vpn_1_1IRouteManager.md#using-ipvariant-t)**  |

## Public Functions

|                | Name           |
| -------------- | -------------- |
| | **[IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-iroutemanager)**() =default |
| | **[IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-iroutemanager)**(const [IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md) & ) =delete |
| | **[IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-iroutemanager)**([IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md) && ) =delete |
| virtual | **[~IRouteManager](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-~iroutemanager)**() =default |
| virtual void | **[AddRoute](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-addroute)**(IPVariant_t ip, IPVariant_t gateway) =0 |
| virtual void | **[DelRoute](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-delroute)**(IPVariant_t ip, IPVariant_t gateway) =0 |
| virtual void | **[AddDefaultRouteViaInterface](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-adddefaultrouteviainterface)**(std::string ifname) =0 |
| virtual void | **[DelDefaultRouteViaInterface](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-deldefaultrouteviainterface)**(std::string ifname) =0 |
| virtual void | **[AddRouteViaInterface](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-addrouteviainterface)**([NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md) & vpn, [IPRange](Classes/structllarp_1_1IPRange.md) range) =0 |
| virtual void | **[DelRouteViaInterface](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-delrouteviainterface)**([NetworkInterface](Classes/classllarp_1_1vpn_1_1NetworkInterface.md) & vpn, [IPRange](Classes/structllarp_1_1IPRange.md) range) =0 |
| virtual std::vector< IPVariant_t > | **[GetGatewaysNotOnInterface](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-getgatewaysnotoninterface)**(std::string ifname) =0 |
| virtual void | **[AddBlackhole](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-addblackhole)**() |
| virtual void | **[DelBlackhole](Classes/classllarp_1_1vpn_1_1IRouteManager.md#function-delblackhole)**() |

## Public Types Documentation

### using IPVariant_t

```cpp
using llarp::vpn::IRouteManager::IPVariant_t =  std::variant<huint32_t, huint128_t>;
```


## Public Functions Documentation

### function IRouteManager

```cpp
IRouteManager() =default
```


### function IRouteManager

```cpp
IRouteManager(
    const IRouteManager & 
) =delete
```


### function IRouteManager

```cpp
IRouteManager(
    IRouteManager && 
) =delete
```


### function ~IRouteManager

```cpp
virtual ~IRouteManager() =default
```


### function AddRoute

```cpp
virtual void AddRoute(
    IPVariant_t ip,
    IPVariant_t gateway
) =0
```


**Reimplemented by**: [llarp::apple::RouteManager::AddRoute](Classes/classllarp_1_1apple_1_1RouteManager.md#function-addroute), [llarp::vpn::LinuxRouteManager::AddRoute](Classes/classllarp_1_1vpn_1_1LinuxRouteManager.md#function-addroute), [llarp::vpn::Win32RouteManager::AddRoute](Classes/classllarp_1_1vpn_1_1Win32RouteManager.md#function-addroute), [llarp::vpn::AndroidRouteManager::AddRoute](Classes/classllarp_1_1vpn_1_1AndroidRouteManager.md#function-addroute)


### function DelRoute

```cpp
virtual void DelRoute(
    IPVariant_t ip,
    IPVariant_t gateway
) =0
```


**Reimplemented by**: [llarp::apple::RouteManager::DelRoute](Classes/classllarp_1_1apple_1_1RouteManager.md#function-delroute), [llarp::vpn::LinuxRouteManager::DelRoute](Classes/classllarp_1_1vpn_1_1LinuxRouteManager.md#function-delroute), [llarp::vpn::Win32RouteManager::DelRoute](Classes/classllarp_1_1vpn_1_1Win32RouteManager.md#function-delroute), [llarp::vpn::AndroidRouteManager::DelRoute](Classes/classllarp_1_1vpn_1_1AndroidRouteManager.md#function-delroute)


### function AddDefaultRouteViaInterface

```cpp
virtual void AddDefaultRouteViaInterface(
    std::string ifname
) =0
```


**Reimplemented by**: [llarp::apple::RouteManager::AddDefaultRouteViaInterface](Classes/classllarp_1_1apple_1_1RouteManager.md#function-adddefaultrouteviainterface), [llarp::vpn::LinuxRouteManager::AddDefaultRouteViaInterface](Classes/classllarp_1_1vpn_1_1LinuxRouteManager.md#function-adddefaultrouteviainterface), [llarp::vpn::Win32RouteManager::AddDefaultRouteViaInterface](Classes/classllarp_1_1vpn_1_1Win32RouteManager.md#function-adddefaultrouteviainterface), [llarp::vpn::AndroidRouteManager::AddDefaultRouteViaInterface](Classes/classllarp_1_1vpn_1_1AndroidRouteManager.md#function-adddefaultrouteviainterface)


### function DelDefaultRouteViaInterface

```cpp
virtual void DelDefaultRouteViaInterface(
    std::string ifname
) =0
```


**Reimplemented by**: [llarp::apple::RouteManager::DelDefaultRouteViaInterface](Classes/classllarp_1_1apple_1_1RouteManager.md#function-deldefaultrouteviainterface), [llarp::vpn::LinuxRouteManager::DelDefaultRouteViaInterface](Classes/classllarp_1_1vpn_1_1LinuxRouteManager.md#function-deldefaultrouteviainterface), [llarp::vpn::Win32RouteManager::DelDefaultRouteViaInterface](Classes/classllarp_1_1vpn_1_1Win32RouteManager.md#function-deldefaultrouteviainterface), [llarp::vpn::AndroidRouteManager::DelDefaultRouteViaInterface](Classes/classllarp_1_1vpn_1_1AndroidRouteManager.md#function-deldefaultrouteviainterface)


### function AddRouteViaInterface

```cpp
virtual void AddRouteViaInterface(
    NetworkInterface & vpn,
    IPRange range
) =0
```


**Reimplemented by**: [llarp::vpn::AndroidRouteManager::AddRouteViaInterface](Classes/classllarp_1_1vpn_1_1AndroidRouteManager.md#function-addrouteviainterface), [llarp::vpn::LinuxRouteManager::AddRouteViaInterface](Classes/classllarp_1_1vpn_1_1LinuxRouteManager.md#function-addrouteviainterface), [llarp::vpn::Win32RouteManager::AddRouteViaInterface](Classes/classllarp_1_1vpn_1_1Win32RouteManager.md#function-addrouteviainterface), [llarp::apple::RouteManager::AddRouteViaInterface](Classes/classllarp_1_1apple_1_1RouteManager.md#function-addrouteviainterface)


### function DelRouteViaInterface

```cpp
virtual void DelRouteViaInterface(
    NetworkInterface & vpn,
    IPRange range
) =0
```


**Reimplemented by**: [llarp::vpn::AndroidRouteManager::DelRouteViaInterface](Classes/classllarp_1_1vpn_1_1AndroidRouteManager.md#function-delrouteviainterface), [llarp::vpn::LinuxRouteManager::DelRouteViaInterface](Classes/classllarp_1_1vpn_1_1LinuxRouteManager.md#function-delrouteviainterface), [llarp::vpn::Win32RouteManager::DelRouteViaInterface](Classes/classllarp_1_1vpn_1_1Win32RouteManager.md#function-delrouteviainterface), [llarp::apple::RouteManager::DelRouteViaInterface](Classes/classllarp_1_1apple_1_1RouteManager.md#function-delrouteviainterface)


### function GetGatewaysNotOnInterface

```cpp
virtual std::vector< IPVariant_t > GetGatewaysNotOnInterface(
    std::string ifname
) =0
```


**Reimplemented by**: [llarp::apple::RouteManager::GetGatewaysNotOnInterface](Classes/classllarp_1_1apple_1_1RouteManager.md#function-getgatewaysnotoninterface), [llarp::vpn::LinuxRouteManager::GetGatewaysNotOnInterface](Classes/classllarp_1_1vpn_1_1LinuxRouteManager.md#function-getgatewaysnotoninterface), [llarp::vpn::Win32RouteManager::GetGatewaysNotOnInterface](Classes/classllarp_1_1vpn_1_1Win32RouteManager.md#function-getgatewaysnotoninterface), [llarp::vpn::AndroidRouteManager::GetGatewaysNotOnInterface](Classes/classllarp_1_1vpn_1_1AndroidRouteManager.md#function-getgatewaysnotoninterface)


### function AddBlackhole

```cpp
inline virtual void AddBlackhole()
```


**Reimplemented by**: [llarp::vpn::LinuxRouteManager::AddBlackhole](Classes/classllarp_1_1vpn_1_1LinuxRouteManager.md#function-addblackhole)


### function DelBlackhole

```cpp
inline virtual void DelBlackhole()
```


**Reimplemented by**: [llarp::vpn::LinuxRouteManager::DelBlackhole](Classes/classllarp_1_1vpn_1_1LinuxRouteManager.md#function-delblackhole)


-------------------------------

Updated on 2022-06-19 at 00:14:50 +0000